//+------------------------------------------------------------------+
//|                                           cMessagePipeCommon.mqh |
//|                                                            micle |
//|                            https://login.mql5.com/ru/users/micle |
//+------------------------------------------------------------------+
#property copyright "micle"
#property link      "https://login.mql5.com/ru/users/micle"
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
#define DEFAULT_MAX_PIPES  1
#define PIPE_BASE_NAME     "\\\\.\\pipe\\mt5-"     // MUST tally with client code

#define PIPE_ACCESS_INBOUND            1
#define PIPE_ACCESS_OUTBOUND           2
#define PIPE_ACCESS_DUPLEX             3

#define PIPE_TYPE_MESSAGE              4
#define PIPE_READMODE_MESSAGE          2
#define PIPE_NOWAIT                    1
#define PIPE_WAIT                      0

#define PIPE_UNLIMITED_INSTANCES       255

//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
#import "kernel32.dll"
   int CreateNamedPipeW(string pipeName, int openMode, int pipeMode,int maxInstances,int outBufferSize,int inBufferSize,int defaultTimeOut,int security);
   int CreateNamedPipeA(string pipeName, int openMode, int pipeMode,int maxInstances,int outBufferSize,int inBufferSize,int defaultTimeOut,int security);
   //int PeekNamedPipe(int PipeHandle, int PassAsZero, int PassAsZero2, int PassAsZero3, int & BytesAvailable[], int PassAsZero4);
   int PeekNamedPipe(int PipeHandle, int PassAsZero, int PassAsZero2, int PassAsZero3, int &BytesAvailable, int PassAsZero4);
   
   int CreateFileA(string Filename, int AccessMode, int ShareMode, int PassAsZero, int CreationMode, int FlagsAndAttributes, int AlsoPassAsZero);
   int CloseHandle(int fileHandle);

   int ReadFile(int FileHandle, string &buffer, int BufferLength, int &BytesRead, int PassAsZero);

#import

//+------------------------------------------------------------------+
//| EX5 imports                                                      |
//+------------------------------------------------------------------+
