#property copyright "micle"
#property link      "https://login.mql5.com/ru/users/micle"
#property version   "1.00"

#define PIPE_ACCESS_DUPLEX             3

#define PIPE_TYPE_MESSAGE              4
#define PIPE_READMODE_MESSAGE          2
#define PIPE_NOWAIT                    1

#define PIPE_UNLIMITED_INSTANCES       255


#import "kernel32.dll"
   int CreateNamedPipeW(string pipeName, int openMode, int pipeMode,int maxInstances,int outBufferSize,int inBufferSize,int defaultTimeOut,int security);
   int CloseHandle(int fileHandle);
   int PeekNamedPipe(int PipeHandle, int PassAsZero, int PassAsZero2, int PassAsZero3, int &BytesAvailable, int PassAsZero4);
   int ReadFile(int FileHandle, string &buffer, int BufferLength, int &BytesRead, int PassAsZero);
#import

int Pipes[5] = {0,0,0,0,0};;
string pipeName = "\\\\.\\pipe\\mt5-test2";

int OnInit()
{
   int openMode = PIPE_ACCESS_DUPLEX;
   int pipeMode = PIPE_NOWAIT | PIPE_TYPE_MESSAGE | PIPE_READMODE_MESSAGE;

   for(int n = 0; n < 5; n++){
      Pipes[n] = CreatePipeInstance();
   }
   Print("5 pipes created");

   return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason)
{
   
}

int CreatePipeInstance()
{
   int openMode = PIPE_ACCESS_DUPLEX;
   int pipeMode = PIPE_TYPE_MESSAGE | PIPE_READMODE_MESSAGE | PIPE_NOWAIT;
   return (CreateNamedPipeW(pipeName, openMode, pipeMode, PIPE_UNLIMITED_INSTANCES, 1000, 1000, 0, 0));
}


void OnTick()
{
   string strReturnValue = "";
   for (int PipeIndex = 0; PipeIndex < 5; PipeIndex++) {
      int BytesAvailable = 0;
      int handle = Pipes[PipeIndex];
      int res = PeekNamedPipe(handle, 0, 0, 0, BytesAvailable, 0);
      if (res != 0) {
         if (BytesAvailable != 0) {
            Print("BytesAvailable=", DoubleToString(BytesAvailable,0));
            int TotalBytesRead = 0;
            while (TotalBytesRead < BytesAvailable) {
               string ReadBuffer;
               StringInit(ReadBuffer, 200, 0);
               int BufferLength = StringBufferLen(ReadBuffer);
               int BytesRead = 0;
               ReadFile(handle, ReadBuffer, BufferLength, BytesRead, 0);
               if (BytesRead > 0) {
                  strReturnValue = strReturnValue + StringSubstr(ReadBuffer, 0, BytesRead/2);
                  TotalBytesRead += BytesRead;
               } else {
                  strReturnValue = "";
                  break;
               }
            }
            CloseHandle(handle);
            Pipes[PipeIndex] = CreatePipeInstance();
            Print("read from ", DoubleToString(PipeIndex,0), " pipe:" , strReturnValue);
         } else {
            // No data available on pipe
         }
      } else {
         // PeekNamedPipe() failed
      }
   }
}
